#include <stdlib.h>
#include "memory.h"
#include "nmd.h"

/*! Stress test */
int main(int argc,char **argv) {
  NMD_metadata nmd; NMDErrorCode ierr; 
  int i;
  PetscFunctionBegin;
  PetscInitialize(&argc,&argv,0,0);

  ierr = NMDCreateObject(&nmd); NMD_ERR_RETURN(ierr);

  /*
   * Test relocation of categories
   */
  for (i=0; i<999; i++) {
    char catname[20];
    memset(catname,0,20);
    sprintf(catname,"cat%d",i);
    ierr = NMDSetValue(nmd,catname,"cmp",NMDInt,&i); NMD_ERR_RETURN(ierr);
  }
  for (i=0; i<999; i++) {
    char catname[20]; int ii; NMDTruth flg;
    memset(catname,0,20);
    sprintf(catname,"cat%d",i);
    ierr = NMDGetValue
      (nmd,catname,"cmp",NULL,(void*)&ii,&flg); NMD_ERR_RETURN(ierr);
    if (!flg)
      NMD_ERR_REPORTi("Could not get value at",i);
    if (i!=ii)
      NMD_ERR_REPORTi("Value mismatch at",i);
  }

  /*
   * Test relocation of components
   */
  for (i=0; i<999; i++) {
    char cmpname[20];
    memset(cmpname,0,20);
    sprintf(cmpname,"cmp%d",i);
    ierr = NMDSetValue(nmd,"testcmp",cmpname,NMDInt,&i); NMD_ERR_RETURN(ierr);
  }
  for (i=0; i<999; i++) {
    char cmpname[20]; int ii; NMDTruth flg;
    memset(cmpname,0,20);
    sprintf(cmpname,"cmp%d",i);
    ierr = NMDGetValue
      (nmd,"testcmp",cmpname,NULL,(void*)&ii,&flg); NMD_ERR_RETURN(ierr);
    if (!flg)
      NMD_ERR_REPORTi("Could not get value at",i);
    if (i!=ii)
      NMD_ERR_REPORTi("Value mismatch at",i);
  }

  ierr = NMDDestroyObject(nmd); NMD_ERR_RETURN(ierr);

  PetscFinalize();
  PetscFunctionReturn(0);
}
